#include <ctime>
#include <cassert>
#include <cstdio>
#include <cstdlib>

#include <vector>
#include <iostream>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define pb push_back

unsigned R() { return (rand() << 15) + rand(); }

typedef long long ll;

const unsigned M = 1; // degree of vertex
const int P = 239017;
const int Q = 17239;

const int maxN = (int)1e7;

int n, m;

void addE( int a, int b );

inline void add( int &a, int b )
{
  if ((a += b) >= n)
    a -= n;
}

double start = clock();
void MiniTimeStamp( const char *s )
{
  fprintf(stderr, "time = %.2f : %s\n", (double)(clock() - start) / CLOCKS_PER_SEC, s);
}

void go()
{
  int a = 0, b = 0;
  assert(P < n && Q < n);
  m = M * n;
  forn(i, m)
  {
    addE(a, b);
    add(a, P), add(b, Q);
  }
}
